Index: /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/batching.py	(revision 9706)
@@ -70,5 +70,5 @@
         return
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
 
@@ -76,9 +76,10 @@
         """
         items_changed = super(AccessCodeBatchProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
         # Log actions...
         location_field = self.location_fields[0]
-        grok.getSite()['accesscodes'].logger.info('%s - %s - Batch updated: %s'
-            % (self.name, row[location_field], items_changed))
+        grok.getSite()['accesscodes'].logger.info(
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, row[location_field], items_changed))
         return
 
@@ -180,5 +181,5 @@
         return None
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
 
@@ -215,8 +216,9 @@
 
         items_changed += super(AccessCodeProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
 
         # Log actions...
-        grok.getSite()['accesscodes'].logger.info('%s - %s - AC updated: %s'
-            % (self.name, row['representation'], items_changed))
-        return
+        grok.getSite()['accesscodes'].logger.info(
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, row['representation'], items_changed))
+        return
Index: /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/tests/test_batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/tests/test_batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/tests/test_batching.py	(revision 9706)
@@ -111,6 +111,7 @@
         logcontent = open(self.logfile).read()
         self.assertTrue(
-            'system - AccessCodeBatch Processor - CLR-1 - '
-            'Batch updated: num=1, creator=system, used_num=1, '
+            'system - AccessCodeBatch Processor - sample_batch_data - '
+            'CLR-1 - updated: '
+            'num=1, creator=system, used_num=1, '
             'entry_num=3, creation_date=2012-04-28 07:28:48.719026+00:00, '
             'prefix=CLR, cost=0.0, disabled_num=0'
@@ -167,6 +168,7 @@
         logcontent = open(self.logfile).read()
         self.assertTrue(
-            'INFO - system - AccessCode Processor - CLR-1-1625368961 - '
-            'AC updated: state=used, batch_serial=33, random_num=1625368961, '
+            'INFO - system - AccessCode Processor - sample_ac_data - '
+            'CLR-1-1625368961 - updated: state=used, '
+            'batch_serial=33, random_num=1625368961, '
             'cost=100.0, owner=K1000009'
             in logcontent)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/batching.py	(revision 9706)
@@ -221,5 +221,5 @@
         pass
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -264,5 +264,5 @@
         # apply other values...
         items_changed += super(ApplicantProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
 
         # Log actions...
@@ -270,8 +270,8 @@
         if self.getLocator(row) == 'container_code':
             parent.__parent__.logger.info(
-                'Applicant imported: %s' % items_changed)
+                '%s - %s - imported: %s' % (self.name, filename, items_changed))
         else:
             parent.__parent__.logger.info(
-                'Applicant updated: %s' % items_changed)
+                '%s - %s - updated: %s' % (self.name, filename, items_changed))
         return items_changed
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 9706)
@@ -304,5 +304,6 @@
         # create applicant with given application_number
         self.assertTrue(
-            'Applicant imported: applicant_id=dp2011_1234, password=mypwd1, '
+            'Applicant Processor - sample_applicant_data - imported: '
+            'applicant_id=dp2011_1234, password=mypwd1, '
             'reg_number=1001, firstname=Aaren, middlename=Peter, lastname=Pieri, '
             'sex=m, course1=CERT1, date_of_birth=1990-01-02, email=xx@yy.zz' in
@@ -311,5 +312,6 @@
         # not shown in the log file
         self.assertTrue(
-            'Applicant imported: reg_number=1003, firstname=Aaren, '
+            'Applicant Processor - sample_applicant_data - imported: '
+            'reg_number=1003, firstname=Aaren, '
             'middlename=Alfons, lastname=Berson, sex=m, course1=CERT1, '
             'date_of_birth=1990-01-04, email=xx@yy.zz' in
@@ -369,9 +371,11 @@
         # reg_number is locator
         self.assertTrue(
-            'Applicant updated: reg_number=1001, firstname=Aaren' in
+            'Applicant Processor - sample_applicant_data_update - updated: '
+            'reg_number=1001, firstname=Aaren' in
             logcontent)
         # applicant_id is locator
         self.assertTrue(
-            'Applicant updated: state=admitted, reg_number=6666, '
+            'Applicant Processor - sample_applicant_data_update - updated: '
+            'state=admitted, reg_number=6666, '
             'firstname=Alfons, applicant_id=dp2011_2345' in
             logcontent)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/authentication.py	(revision 9706)
@@ -426,5 +426,5 @@
         return
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -451,6 +451,6 @@
         # Log actions...
         items_changed = ', '.join(changed)
-        grok.getSite().logger.info('%s - %s - updated: %s'
-            % (self.name, row['name'], items_changed))
+        grok.getSite().logger.info('%s - %s - %s - updated: %s'
+            % (self.name, filename, row['name'], items_changed))
         return
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/hostels/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/hostels/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/hostels/batching.py	(revision 9706)
@@ -62,5 +62,5 @@
         return
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -85,5 +85,6 @@
         location_field = self.location_fields[0]
         items_changed = ', '.join(changed)
-        grok.getSite()['hostels'].logger.info('%s - %s - Record updated: %s'
-            % (self.name, row[location_field], items_changed))
+        grok.getSite()['hostels'].logger.info(
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, row[location_field], items_changed))
         return
Index: /main/waeup.kofa/trunk/src/waeup/kofa/hostels/tests.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/hostels/tests.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/hostels/tests.py	(revision 9706)
@@ -504,6 +504,7 @@
         logcontent = open(self.logfile).read()
         self.assertTrue(
-            "Hostel Processor - block-a-upper-hostel - "
-            "Record updated: beds_for_pre=['G'], floors_per_block=1, "
+            "Hostel Processor - sample_hostel_data - block-a-upper-hostel - "
+            "updated: "
+            "beds_for_pre=['G'], floors_per_block=1, "
             "beds_for_final=['A', 'B'], rooms_per_floor=32, "
             "blocks_for_male=[], hostel_id=block-a-upper-hostel, "
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 9706)
@@ -185,5 +185,5 @@
         return None
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -230,5 +230,5 @@
         # apply other values...
         items_changed += super(StudentProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
 
         # Log actions...
@@ -238,9 +238,13 @@
             # Create mode: the record contains the student_id
             parent.logger.info(
-                '%s - Student record updated: %s'
-                % (obj.student_id, items_changed))
+                '%s - %s - %s - updated: %s'
+                % (self.name, filename, obj.student_id, items_changed))
         else:
             # Create mode: the student does not yet exist
-            parent.logger.info('Student data imported: %s' % items_changed)
+            # XXX: It seems that this never happens because student_id
+            # is always set.
+            parent.logger.info(
+                '%s - %s - %s - imported: %s' 
+                % (self.name, filename, obj.student_id, items_changed))
         return items_changed
 
@@ -418,13 +422,13 @@
         return student.get('studycourse')
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
         items_changed = super(StudentStudyCourseProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
         parent = self.getParent(row, site)
         parent.__parent__.logger.info(
-            '%s - Study course updated: %s'
-            % (parent.student_id, items_changed))
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, parent.student_id, items_changed))
         # Update the students_catalog
         notify(grok.ObjectModifiedEvent(obj.__parent__))
@@ -503,13 +507,13 @@
         return
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
         items_changed = super(StudentStudyLevelProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
         student = self.getParent(row, site).__parent__
         student.__parent__.logger.info(
-            '%s - Study level updated: %s'
-            % (student.student_id, items_changed))
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, student.student_id, items_changed))
         return
 
@@ -574,14 +578,14 @@
         return level.get(row['code'])
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
         items_changed = super(CourseTicketProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
         parent = self.getParent(row, site)
         student = self.getParent(row, site).__parent__.__parent__
         student.__parent__.logger.info(
-            '%s - Course ticket in %s updated: %s'
-            % (student.student_id,  parent.level, items_changed))
+            '%s - %s - %s - %s - updated: %s'
+            % (self.name, filename, student.student_id, parent.level, items_changed))
         return
 
@@ -690,13 +694,13 @@
         return entry
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
         items_changed = super(StudentOnlinePaymentProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
         student = self.getParent(row, site).__parent__
         student.__parent__.logger.info(
-            '%s - Payment ticket updated: %s'
-            % (student.student_id, items_changed))
+            '%s - %s - %s - updated: %s'
+            % (self.name, filename, student.student_id, items_changed))
         return
 
@@ -798,5 +802,5 @@
         return None
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -804,5 +808,6 @@
         vals_to_set = dict((key, val) for key, val in row.items()
                            if key not in ('current_session','current_level'))
-        super(StudentVerdictProcessor, self).updateEntry(obj, vals_to_set, site)
+        super(StudentVerdictProcessor, self).updateEntry(
+            obj, vals_to_set, site, filename)
         parent = self.getParent(row, site)
         # Set current_vedict in corresponding studylevel
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 9706)
@@ -666,6 +666,7 @@
         # Logging message from updateEntry,
         self.assertTrue(
-            'INFO - system - K1000000 - Study level '
-            'updated: level=100, level_verdict=C, level_session=2009'
+            'INFO - system - StudentStudyLevel Processor - '
+            'sample_studylevel_data - K1000000 - updated: '
+            'level=100, level_verdict=C, level_session=2009'
             in logcontent)
 
@@ -788,9 +789,10 @@
         self.assertEqual(courseticket.semester, 1)
         shutil.rmtree(os.path.dirname(fin_file))
-
         logcontent = open(self.logfile).read()
         # Logging message from updateEntry,
         self.assertTrue(
-            'INFO - system - K1000000 - Course ticket in 100 updated: code=COURSE1, '
+            'INFO - system - CourseTicket Processor - '
+            'sample_courseticket_data - K1000000 - 100 - '
+            'updated: code=COURSE1, '
             'mandatory=False, score=3'
             in logcontent)
@@ -968,5 +970,6 @@
         # Logging message from updateEntry
         self.assertTrue(
-            'INFO - system - K1000001 - Payment ticket updated: '
+            'INFO - system - Student Payment Processor - '
+            'sample_payment_data - K1000001 - updated: '
             'p_item=BTECHBDT, creation_date=2010-02-15 13:19:01+00:00, '
             'p_category=schoolfee, amount_auth=19500.0, p_current=True, '
@@ -975,5 +978,6 @@
             in logcontent)
         self.assertTrue(
-            'INFO - system - K1000001 - Payment ticket updated: '
+            'INFO - system - Student Payment Processor - '
+            'sample_payment_data - K1000001 - updated: '
             'p_item=BTECHBDT, creation_date=2010-02-15 13:19:01+00:00, '
             'p_category=schoolfee, amount_auth=19500.6, p_current=True, '
@@ -1089,5 +1093,7 @@
         logcontent = open(self.logfile).read()
         self.assertMatches(
-            '... INFO - system - X666666 - Study course updated: current_verdict=0...',
+            '... INFO - system - Verdict Processor (special processor, '
+            'update only) - sample_verdict_data - X666666 - '
+            'updated: current_verdict=0...',
             logcontent)
         self.assertMatches(
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/batching.py	(revision 9706)
@@ -92,5 +92,5 @@
         pass
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
         """
@@ -120,10 +120,10 @@
         # apply other values...
         items_changed += super(FacultyProcessor, self).updateEntry(
-            obj, row, site)
+            obj, row, site, filename)
 
         # Log actions...
         location_field = self.location_fields[0]
-        grok.getSite().logger.info('%s - %s - Record updated: %s'
-            % (self.name, row[location_field], items_changed))
+        grok.getSite().logger.info('%s - %s - %s - updated: %s'
+            % (self.name, filename, row[location_field], items_changed))
         return items_changed
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py	(revision 9706)
@@ -205,5 +205,5 @@
         return None
 
-    def updateEntry(self, obj, row, site):
+    def updateEntry(self, obj, row, site, filename):
         """Update obj to the values given in row.
 
@@ -350,5 +350,5 @@
                 # student_ids and applicant_ids which have been
                 # generated in the respective __init__ methods before.
-                self.updateEntry(obj, row, site)
+                self.updateEntry(obj, row, site, base)
                 try:
                     self.addEntry(obj, row, site)
@@ -387,5 +387,5 @@
                         failed_writer, string_row, update_errors)
                     continue
-                self.updateEntry(obj, row, site)
+                self.updateEntry(obj, row, site, base)
             finished_writer.writerow(string_row)
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 9705)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 9706)
@@ -218,5 +218,5 @@
     ...     stoneville[row['name']] = obj
     ...
-    ...   def updateEntry(self, obj, row, site):
+    ...   def updateEntry(self, obj, row, site, filename):
     ...     # This is not strictly necessary, as the default
     ...     # updateEntry method does exactly the same