Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 9696)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 9724)
@@ -129,10 +129,15 @@
                            self.browser.contents)
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['gown']
-        self.browser.getControl("Create ticket").click()
-        self.assertMatches('...ticket created...',
-                           self.browser.contents)
-        self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['transfer']
+        self.browser.getControl(name="form.p_category").value = ['co1']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['co2']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['co3']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -251,29 +256,36 @@
         self.assertEqual(error, None)
 
-        error, payment = utils.setPaymentDetails('gown',self.student)
+        error, payment = utils.setPaymentDetails('co1',self.student)
+        self.assertEqual(payment.p_level, 100)
+        self.assertEqual(payment.p_session, 2004)
+        self.assertEqual(payment.amount_auth, 6000.0)
+        self.assertEqual(payment.p_item, u'')
+        self.assertEqual(error, None)
+
+        error, payment = utils.setPaymentDetails('co2',self.student)
+        self.assertEqual(payment.p_level, 100)
+        self.assertEqual(payment.p_session, 2004)
+        self.assertEqual(payment.amount_auth, 7000.0)
+        self.assertEqual(payment.p_item, u'')
+        self.assertEqual(error, None)
+
+        error, payment = utils.setPaymentDetails('co3',self.student)
+        self.assertEqual(payment.p_level, 100)
+        self.assertEqual(payment.p_session, 2004)
+        self.assertEqual(payment.amount_auth, 8000.0)
+        self.assertEqual(payment.p_item, u'')
+        self.assertEqual(error, None)
+
+        error, payment = utils.setPaymentDetails('hostel_maintenance',self.student)
+        self.assertEqual(payment.p_level, 100)
+        self.assertEqual(payment.p_session, 2004)
+        self.assertEqual(payment.amount_auth, 180.0)
+        self.assertEqual(payment.p_item, u'')
+        self.assertEqual(error, None)
+
+        error, payment = utils.setPaymentDetails('bed_allocation',self.student)
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
         self.assertEqual(payment.amount_auth, 150.0)
-        self.assertEqual(payment.p_item, u'')
-        self.assertEqual(error, None)
-
-        error, payment = utils.setPaymentDetails('hostel_maintenance',self.student)
-        self.assertEqual(payment.p_level, 100)
-        self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 180.0)
-        self.assertEqual(payment.p_item, u'')
-        self.assertEqual(error, None)
-
-        error, payment = utils.setPaymentDetails('bed_allocation',self.student)
-        self.assertEqual(payment.p_level, 100)
-        self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 150.0)
-        self.assertEqual(payment.p_item, u'')
-        self.assertEqual(error, None)
-
-        error, payment = utils.setPaymentDetails('transfer',self.student)
-        self.assertEqual(payment.p_level, 100)
-        self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 90.0)
         self.assertEqual(payment.p_item, u'')
         self.assertEqual(error, None)
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 9696)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 9724)
@@ -164,4 +164,10 @@
                          p_level)
                         )
+        elif category == 'co1':
+            amount = 6000.0
+        elif category == 'co2':
+            amount = 7000.0
+        elif category == 'co3':
+            amount = 8000.0
         if amount in (0.0, None):
             return _(u'Amount could not be determined.'), None