Index: /main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9730)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9731)
@@ -209,5 +209,5 @@
             self.browser.contents)
         self.assertMatches(
-            '...<item_detail item_id="1" item_name="Hostel Maint. Fee" item_amt="800000" bank_id="129" acct_num="0014414547" />...',
+            '...<item_detail item_id="1" item_name="Hostel Maintenance Fee" item_amt="800000" bank_id="129" acct_num="0014414547" />...',
             self.browser.contents)
         self.assertFalse(
Index: /main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9730)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9731)
@@ -221,4 +221,5 @@
         self.student.nationality = u'NG'
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -237,4 +238,5 @@
         ticket.p_state = 'paid'
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...This type of payment has already been made...',
@@ -245,4 +247,5 @@
             del self.student['payments'][payment]
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -255,11 +258,6 @@
                            self.browser.contents)
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['transfer']
-        self.browser.getControl("Create ticket").click()
-        self.assertMatches('...ticket created...',
-                           self.browser.contents)
-        self.browser.open(self.payments_path + '/addop')
         self.browser.getControl(
-            name="form.p_category").value = ['bed_allocation']
+            name="form.p_category").value = ['tempmaint_1']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -267,5 +265,11 @@
         self.browser.open(self.payments_path + '/addop')
         self.browser.getControl(
-            name="form.p_category").value = ['hostel_maintenance']
+            name="form.p_category").value = ['tempmaint_2']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(
+            name="form.p_category").value = ['tempmaint_3']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
Index: /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 9730)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/utils/utils.py	(revision 9731)
@@ -50,5 +50,5 @@
         'clearance': 'Acceptance Fee',
         'bed_allocation': 'Bed Allocation Fee',
-        'hostel_maintenance': 'Hostel Maint. Fee',
+        'hostel_maintenance': 'Hostel Maintenance Fee',
         'tempmaint_1': 'Hall 1-4 M/F Ekehuan',
         'tempmaint_2': 'Hall 5 M/F',
@@ -58,2 +58,12 @@
         'application': 'Application Fee'
         }
+
+    SELECTABLE_PAYMENT_CATEGORIES = {
+        'schoolfee': 'School Fee',
+        'clearance': 'Acceptance Fee',
+        'tempmaint_1': 'Hall 1-4 M/F Ekehuan Maintenance Fee',
+        'tempmaint_2': 'Hall 5 M/F Maintenance Fee',
+        'tempmaint_3': 'Clinical Hostel Maintenance Fee',
+        'gown': 'Gown Hire Fee',
+        'application': 'Application Fee'
+        }