Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt	(revision 9738)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt	(revision 9739)
@@ -153,15 +153,6 @@
     >>> browser.getControl(name='query').value = "zope.mgr"
     >>> browser.getControl('Search').click()
-    >>> 'zope.mgr: Batch processing finished: OK' in browser.contents
+    >>> 'zope.mgr - processed' in browser.contents
     True
-    >>> 'Mode: create' in browser.contents
-    True
-
-    >>> browser.getControl(name='query').value = "finished"
-    >>> browser.getControl('Search').click()
-    >>> 'zope.mgr: Batch processing finished: OK' in browser.contents
-    True
-    >>> 'Mode: create' in browser.contents
-    False
 
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py	(revision 9738)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.py	(revision 9739)
@@ -244,21 +244,9 @@
         if logger is None:
             return
-        status = 'OK'
-        if warnings > 0:
-            status = 'FAILED'
-        logger.info("-" * 20)
-        logger.info("%s: Batch processing finished: %s" % (user, status))
-        logger.info("%s: Source: %s" % (user, path))
-        logger.info("%s: Mode: %s" % (user, mode))
-        logger.info("%s: User: %s" % (user, user))
-        if warnings > 0:
-            logger.info("%s: Failed datasets: %s" % (
-                    user, os.path.basename(fail_path)))
-        logger.info("%s: Processing time: %0.3f s (%0.4f s/item)" % (
-                user, timedelta, timedelta/(num or 1)))
-        logger.info("%s: Processed: %s lines (%s successful/ %s failed)" % (
-                user, num, num - warnings, warnings
-                ))
-        logger.info("-" * 20)
+        logger.info(
+            "processed: %s, %s mode, %s lines (%s successful/ %s failed), "
+            "%0.3f s (%0.4f s/item)" % (
+            path, mode, num, num - warnings, warnings,
+            timedelta, timedelta/(num or 1)))
         return
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 9738)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 9739)
@@ -277,12 +277,6 @@
 
     >>> print open('stoneville.log').read()
-    --------------------
-    Bob: Batch processing finished: OK
-    Bob: Source: newcomers.csv
-    Bob: Mode: create
-    Bob: User: Bob
-    Bob: Processing time: ... s (... s/item)
-    Bob: Processed: 4 lines (4 successful/ 0 failed)
-    --------------------
+    processed: newcomers.csv, create mode, 4 lines (4 successful/ 0 failed), ... s (... s/item)
+
 
 We cleanup the temporay dir created by doImport():
@@ -306,15 +300,7 @@
 
     >>> print open('stoneville.log').read()
-    --------------------
-    ...
-    --------------------
-    Bob: Batch processing finished: FAILED
-    Bob: Source: newcomers.csv
-    Bob: Mode: create
-    Bob: User: Bob
-    Bob: Failed datasets: newcomers.pending.csv
-    Bob: Processing time: ... s (... s/item)
-    Bob: Processed: 4 lines (0 successful/ 4 failed)
-    --------------------
+    processed: newcomers.csv, create mode, 4 lines (4 successful/ 0 failed), ... s (... s/item)
+    processed: newcomers.csv, create mode, 4 lines (0 successful/ 4 failed), ... s (... s/item)
+
 
 This time a new file was created, which keeps all the rows we could not
Index: /main/waeup.kofa/trunk/src/waeup/kofa/utils/tests/test_batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/utils/tests/test_batching.py	(revision 9738)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/utils/tests/test_batching.py	(revision 9739)
@@ -218,12 +218,5 @@
         """
            >>> print log_contents
-           --------------------
-           Bob: Batch processing finished: OK
-           Bob: Source: /.../newcomers.csv
-           Bob: Mode: create
-           Bob: User: Bob
-           Bob: Processing time: ... s (... s/item)
-           Bob: Processed: 4 lines (4 successful/ 0 failed)
-           --------------------
+           processed: /.../newcomers.csv, create mode, 4 lines (4 successful/ 0 failed), ... s (... s/item)
 
         """