Index: main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 9754)
+++ main/waeup.aaue/trunk/src/waeup/aaue/etranzact/tests.py	(revision 9755)
@@ -54,4 +54,5 @@
         IWorkflowState(self.student).setState('cleared')
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_1']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
Index: main/waeup.aaue/trunk/src/waeup/aaue/payments/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/payments/interfaces.py	(revision 9754)
+++ main/waeup.aaue/trunk/src/waeup/aaue/payments/interfaces.py	(revision 9755)
@@ -16,97 +16,8 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-from zope.interface import Attribute
-from zope import schema
-from waeup.kofa.payments.interfaces import IPayment
-from waeup.kofa.interfaces import SimpleKofaVocabulary
-from waeup.aaue.interfaces import MessageFactory as _
+from kofacustom.nigeria.payments.interfaces import INigeriaOnlinePayment
 
-payment_categories = SimpleKofaVocabulary(
-    (_('School Fee'),'schoolfee'),
-    (_('School Fee 1st instalment'),'schoolfee_1'),
-    (_('School Fee 2nd instalment'),'schoolfee_2'),
-    (_('Clearance'),'clearance'),
-    (_('Bed Allocation'),'bed_allocation'),
-    (_('Hostel Maintenance'),'hostel_maintenance'),
-    (_('Transfer'),'transfer'),
-    (_('Gown'),'gown'),
-    (_('Application Fee'), 'application'),
-    )
-
-class ICustomOnlinePayment(IPayment):
+class ICustomOnlinePayment(INigeriaOnlinePayment):
     """A payment via payment gateways.
 
-    This is a copy of INigeriaOnlinePayment
-    only for taking the AAUE payment_categories
-    into consideration.
     """
-
-
-    p_category = schema.Choice(
-        title = _(u'Payment Category'),
-        default = u'schoolfee_1',
-        vocabulary = payment_categories,
-        required = True,
-        )
-
-    ac = schema.TextLine(
-        title = _(u'Activation Code'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    r_amount_approved = schema.Float(
-        title = _(u'Response Amount Approved'),
-        default = 0.0,
-        required = False,
-        readonly = False,
-        )
-
-    r_code = schema.TextLine(
-        title = _(u'Response Code'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    r_desc = schema.TextLine(
-        title = _(u'Response Description'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    r_pay_reference = schema.TextLine(
-        title = _(u'Response Payment Reference'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    r_card_num = schema.TextLine(
-        title = _(u'Response Card Number'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    conf_number = schema.TextLine(
-        title = _(u'Confirmation Number'),
-        default = None,
-        required = False,
-        readonly = False,
-        )
-
-    r_company = schema.Choice(
-        title = _(u'Payment Gateway'),
-        default = None,
-        required = False,
-        readonly = False,
-        vocabulary = SimpleKofaVocabulary(
-            (_('Interswitch'), 'interswitch'),
-            (_('eTranzact'), 'etranzact'),)
-        )
-
-ICustomOnlinePayment['p_category'].order = ICustomOnlinePayment[
-    'p_category'].order
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py	(revision 9754)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/payments.py	(revision 9755)
@@ -27,5 +27,4 @@
 from waeup.kofa.utils.helpers import attrs_to_fields
 from waeup.aaue.students.interfaces import ICustomStudentOnlinePayment
-from waeup.aaue.payments.interfaces import payment_categories
 
 class CustomStudentOnlinePayment(StudentOnlinePayment):
@@ -48,8 +47,4 @@
         return self.__parent__.__parent__
 
-    @property
-    def category(self):
-        return payment_categories.getTermByToken(self.p_category).title
-
 CustomStudentOnlinePayment = attrs_to_fields(CustomStudentOnlinePayment)
 
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 9754)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 9755)
@@ -92,4 +92,5 @@
         self.browser.open(self.payments_path)
         self.browser.getLink("Add current session payment ticket").click()
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_1']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...Wrong state...',
@@ -101,4 +102,5 @@
                            self.browser.contents)
         self.app['configuration']['2004'].school_fee_base = 6666.0
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_1']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...ticket created...',
@@ -117,4 +119,5 @@
         ticket.p_state = 'paid'
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee_1']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...This type of payment has already been made...',
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 9754)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 9755)
@@ -26,2 +26,26 @@
     PREFERRED_LANGUAGES_DICT = {
         }
+
+    PAYMENT_CATEGORIES = {
+        'schoolfee': 'School Fee',
+        'schoolfee_1': 'School Fee 1st instalment',
+        'schoolfee_2': 'School Fee 2nd instalment',
+        'clearance': 'Acceptance Fee',
+        'hostel_maintenance': 'Hostel Maintenance Fee',
+        'application': 'Application Fee',
+        'gown': 'Gown Hire Fee',
+        'bed_allocation': 'Bed Allocation Fee',
+        'transfer': 'Transfer Fee',
+        }
+
+    SELECTABLE_PAYMENT_CATEGORIES = {
+        'schoolfee_1': 'School Fee 1st instalment',
+        'schoolfee_2': 'School Fee 2nd instalment',
+        'clearance': 'Acceptance Fee',
+        'hostel_maintenance': 'Hostel Maintenance Fee',
+        'application': 'Application Fee',
+        'gown': 'Gown Hire Fee',
+        'bed_allocation': 'Bed Allocation Fee',
+        'transfer': 'Transfer Fee',
+        }
+